Index: trunk/XTIDE_Universal_BIOS/Src/Device/Device.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Device/Device.asm	(revision 150)
+++ trunk/XTIDE_Universal_BIOS/Src/Device/Device.asm	(revision 150)
@@ -0,0 +1,188 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Command and port direction functions for different device types.
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; Device_FinalizeDPT
+;	Parameters:
+;		DS:DI:	Ptr to Disk Parameter Table
+;		ES:SI:	Ptr to 512-byte ATA information read from the drive
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, BX, CX, DX
+;--------------------------------------------------------------------
+Device_FinalizeDPT:
+	test	WORD [di+DPT.wFlags], FLG_DPT_SERIAL_DEVICE
+	jnz		SHORT ReturnSuccessForSerialPort
+	jmp		IdeDPT_Finalize
+.FinalizeDptForSerialPortDevice:
+	jmp		SerialDPT_Finalize
+
+
+;--------------------------------------------------------------------
+; Device_ResetMasterAndSlaveController
+;	Parameters:
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BX, CX, DX
+;--------------------------------------------------------------------
+Device_ResetMasterAndSlaveController:
+	test	WORD [di+DPT.wFlags], FLG_DPT_SERIAL_DEVICE
+	jnz		SHORT ReturnSuccessForSerialPort
+	jmp		IdeCommand_ResetMasterAndSlaveController
+
+
+;--------------------------------------------------------------------
+; Device_IdentifyToBufferInESSIwithDriveSelectByteInBH
+;	Parameters:
+;		BH:		Drive Select byte for Drive and Head Select Register
+;		DS:		Segment to RAMVARS
+;		ES:SI:	Ptr to buffer to receive 512-byte IDE Information
+;		CS:BP:	Ptr to IDEVARS
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BL, CX, DX, SI, DI, ES
+;--------------------------------------------------------------------
+Device_IdentifyToBufferInESSIwithDriveSelectByteInBH:
+	cmp		BYTE [cs:bp+IDEVARS.bDevice], DEVICE_SERIAL_PORT
+	je		SHORT .IdentifyDriveFromSerialPort
+	jmp		IdeCommand_IdentifyDeviceToBufferInESSIwithDriveSelectByteInBH
+.IdentifyDriveFromSerialPort:
+	jmp		SerialCommand_IdentifyDeviceToBufferInESSIwithDriveSelectByteInBH
+
+
+;--------------------------------------------------------------------
+; Device_OutputCommandWithParameters
+;	Parameters:
+;		BH:		Default system timer ticks for timeout (can be ignored)
+;		BL:		IDE Status Register bit to poll after command
+;		ES:SI:	Ptr to buffer (for data transfer commands)
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEPACK
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BX, CX, DX, (ES:SI for data transfer commands)
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+Device_OutputCommandWithParameters:
+	call	IdeIrq_SetInServiceDPTandClearTaskFlag
+	test	WORD [di+DPT.wFlags], FLG_DPT_SERIAL_DEVICE
+	jnz		SHORT .OutputCommandToSerialPort
+	jmp		IdeCommand_OutputWithParameters
+ALIGN JUMP_ALIGN
+.OutputCommandToSerialPort:
+	jmp		SerialCommand_OutputWithParameters
+
+
+;--------------------------------------------------------------------
+; Device_SelectDrive
+;	Parameters:
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEPACK
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BX, CX, DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+Device_SelectDrive:
+	test	WORD [di+DPT.wFlags], FLG_DPT_SERIAL_DEVICE
+	jnz		SHORT ReturnSuccessForSerialPort
+	jmp		IdeCommand_SelectDrive
+ReturnSuccessForSerialPort:
+	xor		ax, ax
+	ret
+
+
+;--------------------------------------------------------------------
+; Device_OutputALtoIdeRegisterInDL
+;	Parameters:
+;		AL:		Byte to output
+;		DL:		IDE Register
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		BX, DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+Device_OutputALtoIdeRegisterInDL:
+	mov		bx, IdeIO_OutputALtoIdeRegisterInDX
+	jmp		SHORT TranslateRegisterAddressInDLifNecessaryThenJumpToBX
+
+
+;--------------------------------------------------------------------
+; Device_OutputALtoIdeControlBlockRegisterInDL
+;	Parameters:
+;		AL:		Byte to output
+;		DL:		IDE Control Block Register
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		BX, DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+Device_OutputALtoIdeControlBlockRegisterInDL:
+	mov		bx, IdeIO_OutputALtoIdeControlBlockRegisterInDX
+	jmp		SHORT TranslateRegisterAddressInDLifNecessaryThenJumpToBX
+
+
+;--------------------------------------------------------------------
+; Device_InputToALfromIdeRegisterInDL
+;	Parameters:
+;		DL:		IDE Register
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		AL:		Inputted byte
+;	Corrupts registers:
+;		BX, DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+Device_InputToALfromIdeRegisterInDL:
+	mov		bx, IdeIO_InputToALfromIdeRegisterInDX
+	; Fall to TranslateRegisterAddressInDLifNecessaryThenJumpToBX
+
+
+;--------------------------------------------------------------------
+; TranslateRegisterAddressInDLifNecessaryThenJumpToBX
+;	Parameters:
+;		AL:		Byte to output (if output function in BX)
+;		DL:		IDE Register
+;		BX:		I/O function to jump to
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		AL:		Inputted byte (if input function in BX)
+;	Corrupts registers:
+;		BX, DX
+;--------------------------------------------------------------------
+TranslateRegisterAddressInDLifNecessaryThenJumpToBX:
+	test	WORD [di+DPT.wFlags], FLG_DPT_REVERSED_A0_AND_A3
+	jz		SHORT .JumpToIoFunctionInSI
+
+	; Exchange address lines A0 and A3 from DL
+	mov		dh, MASK_A3_AND_A0_ADDRESS_LINES
+	and		dh, dl							; DH = 0, 1, 8 or 9, we can ignore 0 and 9
+	jz		SHORT .JumpToIoFunctionInSI		; Jump out since DH is 0
+	xor		dh, MASK_A3_AND_A0_ADDRESS_LINES
+	jz		SHORT .JumpToIoFunctionInSI		; Jump out since DH was 9
+	and		dl, ~MASK_A3_AND_A0_ADDRESS_LINES
+	or		dl, dh							; Address lines now reversed
+
+ALIGN JUMP_ALIGN
+.JumpToIoFunctionInSI:
+	push	bx
+	xor		dh, dh
+	eMOVZX	bx, BYTE [di+DPT.bIdevarsOffset]; CS:BX now points to IDEVARS
+	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeCommand.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeCommand.asm	(revision 150)
+++ trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeCommand.asm	(revision 150)
@@ -0,0 +1,217 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	IDE Device Command functions.
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; IdeCommand_ResetMasterAndSlaveController
+;	Parameters:
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BX, CX, DX
+;--------------------------------------------------------------------
+IdeCommand_ResetMasterAndSlaveController:
+	; HSR0: Set_SRST
+	call	AccessDPT_GetDeviceControlByteToAL
+	or		al, FLG_DEVCONTROL_SRST | FLG_DEVCONTROL_nIEN	; Set Reset bit
+	mov		dl, DEVICE_CONTROL_REGISTER_out
+	call	Device_OutputALtoIdeControlBlockRegisterInDL
+	mov		ax, HSR0_RESET_WAIT_US
+	call	HTimer_DelayMicrosecondsFromAX
+
+	; HSR1: Clear_wait
+	call	AccessDPT_GetDeviceControlByteToAL
+	or		al, FLG_DEVCONTROL_nIEN
+	and		al, ~FLG_DEVCONTROL_SRST						; Clear reset bit
+	mov		dl, DEVICE_CONTROL_REGISTER_out
+	call	Device_OutputALtoIdeControlBlockRegisterInDL
+	mov		ax, HSR1_RESET_WAIT_US
+	call	HTimer_DelayMicrosecondsFromAX
+
+	; HSR2: Check_status
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_MOTOR_STARTUP, FLG_STATUS_BSY)
+	jmp		IdeWait_PollStatusFlagInBLwithTimeoutInBH
+
+
+;--------------------------------------------------------------------
+; IdeCommand_IdentifyDeviceToBufferInESSIwithDriveSelectByteInBH
+;	Parameters:
+;		BH:		Drive Select byte for Drive and Head Select Register
+;		DS:		Segment to RAMVARS
+;		ES:SI:	Ptr to buffer to receive 512-byte IDE Information
+;		CS:BP:	Ptr to IDEVARS
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BL, CX, DX, SI, DI, ES
+;--------------------------------------------------------------------
+IdeCommand_IdentifyDeviceToBufferInESSIwithDriveSelectByteInBH:
+	; Create fake DPT to be able to use Device.asm functions
+	call	FindDPT_ForNewDriveToDSDI
+	xor		ax, ax
+	cmp		BYTE [cs:bp+IDEVARS.bDevice], DEVICE_XTIDE_WITH_REVERSED_A3_AND_A0
+	eCMOVE	ax, FLG_DPT_REVERSED_A0_AND_A3
+	or		al, bh
+	mov		[di+DPT.wFlags], ax
+	mov		[di+DPT.bIdevarsOffset], bp
+	mov		BYTE [di+DPT_ATA.bSetBlock], 1	; Block = 1 sector
+
+	; Wait until drive motors have reached max speed
+	cmp		bp, BYTE ROMVARS.ideVars0
+	jne		SHORT .SkipLongWaitSinceDriveIsNotPrimaryMaster
+	test	bh, FLG_DRVNHEAD_DRV
+	jnz		SHORT .SkipLongWaitSinceDriveIsNotPrimaryMaster
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_MOTOR_STARTUP, FLG_STATUS_BSY)
+	call	IdeWait_PollStatusFlagInBLwithTimeoutInBH
+.SkipLongWaitSinceDriveIsNotPrimaryMaster:
+
+	; Create IDEPACK without INTPACK
+	push	bp
+	call	Idepack_FakeToSSBP
+
+	; Prepare to output Identify Device command
+	mov		dl, 1						; Sector count (required by IdeTransfer.asm)
+	mov		al, COMMAND_IDENTIFY_DEVICE
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_IDENTIFY_DEVICE, FLG_STATUS_DRQ)
+	call	Idepack_StoreNonExtParametersAndIssueCommandFromAL
+
+	; Clean stack and return
+	rcl		al, 1		; Store CF
+	add		sp, BYTE SIZE_OF_FAKE_IDEPACK
+	rcr		al, 1		; Restore CF
+	pop		bp
+	ret
+
+
+;--------------------------------------------------------------------
+; IdeCommand_OutputWithParameters
+;	Parameters:
+;		BH:		System timer ticks for timeout
+;		BL:		IDE Status Register bit to poll after command
+;		ES:SI:	Ptr to buffer (for data transfer commands)
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEPACK
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BX, CX, DX, (ES:SI for data transfer commands)
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+IdeCommand_OutputWithParameters:
+	push	bx							; Store status register bits to poll
+
+	; Select Master or Slave drive and output head number or LBA28 top bits
+	call	IdeCommand_SelectDrive
+	jc		SHORT .DriveNotReady
+
+	; Output Device Control Byte to enable or disable interrupts
+	mov		dl, DEVICE_CONTROL_REGISTER_out
+	mov		al, [bp+IDEPACK.bDeviceControl]
+	call	Device_OutputALtoIdeControlBlockRegisterInDL
+
+	; Output Feature Number
+	mov		dl, FEATURES_REGISTER_out
+	mov		al, [bp+IDEPACK.bFeatures]
+	call	Device_OutputALtoIdeRegisterInDL
+
+	; Output Sector Address High (only used by LBA48)
+	mov		ax, [bp+IDEPACK.wSectorCountHighAndLbaLowExt]
+	mov		cx, [bp+IDEPACK.wLbaMiddleAndHighExt]
+	call	OutputSectorCountAndAddress
+
+	; Output Sector Address Low
+	mov		ax, [bp+IDEPACK.wSectorCountAndLbaLow]
+	mov		cx, [bp+IDEPACK.wLbaMiddleAndHigh]
+	call	OutputSectorCountAndAddress
+
+	; Output command
+	mov		dl, COMMAND_REGISTER_out
+	mov		al, [bp+IDEPACK.bCommand]
+	call	Device_OutputALtoIdeRegisterInDL
+
+	; Wait until command completed
+	pop		bx							; Pop status and timeout for polling
+	cmp		bl, FLG_STATUS_DRQ			; Data transfer started?
+	je		SHORT .StartDataTransfer
+	test	BYTE [bp+IDEPACK.bDeviceControl], FLG_DEVCONTROL_nIEN
+	jz		SHORT .WaitForIrqOrRdy
+	jmp		IdeWait_PollStatusFlagInBLwithTimeoutInBH
+
+ALIGN JUMP_ALIGN
+.WaitForIrqOrRdy:
+	jmp		IdeWait_IRQorStatusFlagInBLwithTimeoutInBH
+ALIGN JUMP_ALIGN
+.StartDataTransfer:
+	jmp		IdeTransfer_StartWithCommandInAL
+
+.DriveNotReady:
+	pop		bx							; Clean stack
+ReturnSinceTimeoutWhenPollingBusy:
+	ret
+
+
+;--------------------------------------------------------------------
+; IdeCommand_SelectDrive
+;	Parameters:
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;		SS:BP:	Ptr to IDEPACK
+;	Returns:
+;		AH:		INT 13h Error Code
+;		CF:		Cleared if success, Set if error
+;	Corrupts registers:
+;		AL, BX, CX, DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+IdeCommand_SelectDrive:
+	; Wait until neither Master or Slave Drive is busy
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_BSY, FLG_STATUS_BSY)
+	cmp		BYTE [bp+IDEPACK.bCommand], COMMAND_IDENTIFY_DEVICE
+	eCMOVE	bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_IDENTIFY_DEVICE, FLG_STATUS_BSY)
+	call	IdeWait_PollStatusFlagInBLwithTimeoutInBH
+	jc		SHORT ReturnSinceTimeoutWhenPollingBusy
+
+	; Select Master or Slave Drive
+	mov		dl, DRIVE_AND_HEAD_SELECT_REGISTER
+	mov		al, [bp+IDEPACK.bDrvAndHead]
+	call	Device_OutputALtoIdeRegisterInDL
+	mov		bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_DRDY, FLG_STATUS_DRDY)
+	cmp		BYTE [bp+IDEPACK.bCommand], COMMAND_IDENTIFY_DEVICE
+	eCMOVE	bx, TIMEOUT_AND_STATUS_TO_WAIT(TIMEOUT_IDENTIFY_DEVICE, FLG_STATUS_DRDY)
+	jmp		IdeWait_PollStatusFlagInBLwithTimeoutInBH
+
+
+;--------------------------------------------------------------------
+; OutputSectorCountAndAddress
+;	Parameters:
+;		AH:		LBA low bits (Sector Number)
+;		AL:		Sector Count
+;		CL:		LBA middle bits (Cylinder Number low)
+;		CH:		LBA high bits (Cylinder Number high)
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AL, BX, DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+OutputSectorCountAndAddress:
+	mov		dl, SECTOR_COUNT_REGISTER
+	call	Device_OutputALtoIdeRegisterInDL
+
+	mov		al, ah
+	mov		dl, LBA_LOW_REGISTER
+	call	Device_OutputALtoIdeRegisterInDL
+
+	mov		al, cl
+	mov		dl, LBA_MIDDLE_REGISTER
+	call	Device_OutputALtoIdeRegisterInDL
+
+	mov		al, ch
+	mov		dl, LBA_HIGH_REGISTER
+	jmp		Device_OutputALtoIdeRegisterInDL
Index: trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeDPT.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeDPT.asm	(revision 150)
+++ trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeDPT.asm	(revision 150)
@@ -0,0 +1,38 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Sets IDE Device specific parameters to DPT.
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; IdeDPT_Finalize
+;	Parameters:
+;		DS:DI:	Ptr to Disk Parameter Table
+;		ES:SI:	Ptr to 512-byte ATA information read from the drive
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX, BX, CX, DX
+;--------------------------------------------------------------------
+IdeDPT_Finalize:
+	; Fall to .StoreBlockMode
+
+;--------------------------------------------------------------------
+; .StoreBlockMode
+;	Parameters:
+;		DS:DI:	Ptr to Disk Parameter Table
+;		ES:SI:	Ptr to 512-byte ATA information read from the drive
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+.StoreBlockMode:
+	mov		al, 1
+	mov		ah, [es:si+ATA1.bBlckSize]		; Max block size in sectors
+	mov		[di+DPT_ATA.wSetAndMaxBlock], ax
+	; Fall to .EndDPT
+
+
+.EndDPT:
+	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeError.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeError.asm	(revision 150)
+++ trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeError.asm	(revision 150)
@@ -0,0 +1,93 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	IDE Device error functions.
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; IdeError_GetBiosErrorCodeToAHfromPolledStatusRegisterInAL
+;	Parameters:
+;		AL:		IDE Status Register contents
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		AH:		BIOS error code
+;		CF:		Set if error
+;				Cleared if no error
+;	Corrupts registers:
+;		AL, BX, DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+IdeError_GetBiosErrorCodeToAHfromPolledStatusRegisterInAL:
+	mov		ah, al			; IDE Status Register to AH
+	mov		dl, ERROR_REGISTER_in
+	call	Device_InputToALfromIdeRegisterInDL
+	xchg	al, ah			; Status Register now in AL, Error Register now in AH
+
+	; I don't think anything actually reads these from BDA
+	push	ds
+	LOAD_BDA_SEGMENT_TO	ds, dx
+	mov		[HDBDA.wHDStAndErr], ax
+	pop		ds
+
+	; Fall to GetBiosErrorCodeToAHfromStatusAndErrorRegistersInAX
+
+
+;--------------------------------------------------------------------
+; GetBiosErrorCodeToAHfromStatusAndErrorRegistersInAX
+;	Parameters:
+;		AL:		IDE Status Register contents
+;		AH:		IDE Error Register contents
+;	Returns:
+;		AH:		BIOS INT 13h error code
+;		CF:		Set if error
+;				Cleared if no error
+;	Corrupts registers:
+;		BX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+GetBiosErrorCodeToAHfromStatusAndErrorRegistersInAX:
+	test	al, FLG_STATUS_BSY
+	jz		SHORT .CheckErrorBitsFromStatusRegisterInAL
+	mov		ah, RET_HD_TIMEOUT
+	jmp		SHORT .ReturnBiosErrorCodeInAH
+
+ALIGN JUMP_ALIGN
+.CheckErrorBitsFromStatusRegisterInAL:
+	test	al, FLG_STATUS_DF | FLG_STATUS_CORR | FLG_STATUS_ERR
+	jnz		SHORT .ProcessErrorFromStatusRegisterInAL
+	xor		ah, ah					; No errors, zero AH and CF
+	ret
+
+.ProcessErrorFromStatusRegisterInAL:
+	test	al, FLG_STATUS_ERR		; Error specified in Error register?
+	jnz		SHORT .ConvertBiosErrorToAHfromErrorRegisterInAH
+	mov		ah, RET_HD_ECC			; Assume ECC corrected error
+	test	al, FLG_STATUS_CORR		; ECC corrected error?
+	jnz		SHORT .ReturnBiosErrorCodeInAH
+	mov		ah, RET_HD_CONTROLLER	; Must be Device Fault
+	jmp		SHORT .ReturnBiosErrorCodeInAH
+
+.ConvertBiosErrorToAHfromErrorRegisterInAH:
+	xor		bx, bx					; Clear CF
+.ErrorBitLoop:
+	rcr		ah, 1					; Set CF if error bit set
+	jc		SHORT .LookupErrorCode
+	inc		bx
+	test	ah, ah					; Clear CF
+	jnz		SHORT .ErrorBitLoop
+.LookupErrorCode:
+	mov		ah, [cs:bx+.rgbRetCodeLookup]
+.ReturnBiosErrorCodeInAH:
+	stc								; Set CF since error
+	ret
+
+.rgbRetCodeLookup:
+	db	RET_HD_ADDRMARK		; Bit0=AMNF, Address Mark Not Found
+	db	RET_HD_SEEK_FAIL	; Bit1=TK0NF, Track 0 Not Found
+	db	RET_HD_INVALID		; Bit2=ABRT, Aborted Command
+	db	RET_HD_NOTLOCKED	; Bit3=MCR, Media Change Requested
+	db	RET_HD_NOT_FOUND	; Bit4=IDNF, ID Not Found
+	db	RET_HD_LOCKED		; Bit5=MC, Media Changed
+	db	RET_HD_UNCORRECC	; Bit6=UNC, Uncorrectable Data Error
+	db	RET_HD_BADSECTOR	; Bit7=BBK, Bad Block Detected
+	db	RET_HD_STATUSERR	; When Error Register is zero
Index: trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeIO.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeIO.asm	(revision 150)
+++ trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeIO.asm	(revision 150)
@@ -0,0 +1,57 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	IDE Register I/O functions.
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; IdeIO_OutputALtoIdeRegisterInDX
+;	Parameters:
+;		AL:		Byte to output
+;		DX:		IDE Register
+;		CS:BX:	Ptr to IDEVARS
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+IdeIO_OutputALtoIdeRegisterInDX:
+	add		dx, [cs:bx+IDEVARS.wPort]
+	out		dx, al
+	ret
+
+
+;--------------------------------------------------------------------
+; IdeIO_OutputALtoIdeControlBlockRegisterInDX
+;	Parameters:
+;		AL:		Byte to output
+;		DX:		IDE Control Block Register
+;		CS:BX:	Ptr to IDEVARS
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+IdeIO_OutputALtoIdeControlBlockRegisterInDX:
+	add		dx, [cs:bx+IDEVARS.wPortCtrl]
+	out		dx, al
+	ret
+
+
+;--------------------------------------------------------------------
+; IdeIO_InputToALfromIdeRegisterInDX
+;	Parameters:
+;		DX:		IDE Register
+;		CS:BX:	Ptr to IDEVARS
+;	Returns:
+;		AL:		Inputted byte
+;	Corrupts registers:
+;		DX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+IdeIO_InputToALfromIdeRegisterInDX:
+	add		dx, [cs:bx+IDEVARS.wPort]
+	in		al, dx
+	ret
Index: trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeIrq.asm
===================================================================
--- trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeIrq.asm	(revision 150)
+++ trunk/XTIDE_Universal_BIOS/Src/Device/IDE/IdeIrq.asm	(revision 150)
@@ -0,0 +1,140 @@
+; Project name	:	XTIDE Universal BIOS
+; Description	:	Interrupt handling related functions.
+
+; Section containing code
+SECTION .text
+
+;--------------------------------------------------------------------
+; IdeIrq_WaitForIRQ
+;	Parameters:
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		CF:		Set if wait done by operating system
+;				Cleared if BIOS must perform task flag polling
+;	Corrupts registers:
+;		AX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+IdeIrq_WaitForIRQ:
+
+;--------------------------------------------------------------------
+; .NotifyOperatingSystemAboutWaitingForIRQ
+;	Parameters:
+;		Nothing
+;	Returns:
+;		CF:		Set if wait done by operating system
+;				Cleared if BIOS must perform task flag polling
+;	Corrupts registers:
+;		AX
+;--------------------------------------------------------------------
+.NotifyOperatingSystemAboutWaitingForIRQ:
+	push	ds
+
+	LOAD_BDA_SEGMENT_TO	ds, ax, !		; Zero AX
+	mov		ah, OS_HOOK_DEVICE_BUSY		; Hard disk busy (AX=9000h)
+	cli									; Disable interrupts
+	cmp		al, [BDA.bHDTaskFlg]		; Task flag already set?
+	jc		SHORT .ReturnFromWaitNotify	;  If so, skip OS notification
+	int		BIOS_SYSTEM_INTERRUPT_15h	; OS hook, device busy
+	jnc		SHORT .ReturnFromWaitNotify	; CF cleared, BIOS handles waiting
+
+	; Make sure that OS hooks are supported, otherwise the CF means unsupported function
+	test	ah, ah						; OS hook supported? (clears CF)
+	jnz		SHORT .ReturnFromWaitNotify	; AH has error, BIOS must do the wait
+	stc									; Set CF since wait done by OS
+.ReturnFromWaitNotify:
+	pop		ds
+	sti									; Enable interrupts
+	ret
+
+
+;--------------------------------------------------------------------
+; IdeIrq_SetInServiceDPTandClearTaskFlag
+;	Parameters:
+;		DS:DI:	Ptr to DPT (in RAMVARS segment)
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+IdeIrq_SetInServiceDPTandClearTaskFlag:
+	mov		[RAMVARS.pInServiceDPT], di
+	push	ds
+	LOAD_BDA_SEGMENT_TO	ds, ax, !		; Also zero AX
+	mov		[BDA.bHDTaskFlg], al
+	pop		ds
+	ret
+
+
+;--------------------------------------------------------------------
+; IDE Interrupt Service Routines.
+;
+; IdeIrq_InterruptServiceRoutineForIrqs2to7
+; IdeIrq_InterruptServiceRoutineForIrqs8to15
+;	Parameters:
+;		Nothing
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		Nothing
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+IdeIrq_InterruptServiceRoutineForIrqs2to7:
+	push	di
+	push	ax
+	call	AcknowledgeIdeInterruptAndSetTaskFlag
+
+	mov		al, CMD_END_OF_INTERRUPT
+	jmp		SHORT AcknowledgeMasterInterruptController
+
+
+ALIGN JUMP_ALIGN
+IdeIrq_InterruptServiceRoutineForIrqs8to15:
+	push	di
+	push	ax
+	call	AcknowledgeIdeInterruptAndSetTaskFlag
+
+	mov		al, CMD_END_OF_INTERRUPT	; Load EOI command to AL
+	out		WPORT_8259SL_COMMAND, al	; Acknowledge Slave 8259
+AcknowledgeMasterInterruptController:
+	out		WPORT_8259MA_COMMAND, al	; Acknowledge Master 8259
+
+	; Issue Int 15h, function AX=9100h (Interrupt ready)
+	mov		ax, OS_HOOK_DEVICE_POST<<8	; Interrupt ready, device 0 (HD)
+	int		BIOS_SYSTEM_INTERRUPT_15h
+
+	pop		ax
+	pop		di
+	iret
+
+
+;--------------------------------------------------------------------
+; AcknowledgeIdeInterruptAndSetTaskFlag
+;	Parameters:
+;		Nothing
+;	Returns:
+;		Nothing
+;	Corrupts registers:
+;		AX
+;--------------------------------------------------------------------
+ALIGN JUMP_ALIGN
+AcknowledgeIdeInterruptAndSetTaskFlag:
+	push	ds
+	push	dx
+	push	bx
+
+	; Reading Status Register acknowledges IDE interrupt
+	call	RamVars_GetSegmentToDS
+	mov		di, [RAMVARS.pInServiceDPT]		; DS:DI now points to DPT
+	mov		dl, STATUS_REGISTER_in
+	call	Device_InputToALfromIdeRegisterInDL
+
+	; Set Task Flag
+	LOAD_BDA_SEGMENT_TO	ds, ax
+	mov		BYTE [BDA.bHDTaskFlg], 0FFh		; Set task flag
+
+	pop		bx
+	pop		dx
+	pop		ds
+	ret
